#ifndef __arch_profile_pumaX_h__
#define __arch_profile_pumaX_h__

#include <asm/performance.h>

static const struct _cpucore_profile arm_cpu_config[1] = {
    { cpu_nr_offset: 0, vpe_nr: 1, next_core: NULL },
};
#define PROFILING_PERFORMANCE_COUNTER_SUPPORT
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static inline void arch_profile_perfcnt_on(unsigned int on) {
    union __performance_monitor_control C;
    if(on) {
        write_secure_debug_enable_register(0, 1);
        C.Register = read_p15_performance_monitor_control();
        C.Bits.CycleCounterDivider = 1; /*--- / 64 * 32 = takt / 2 ->  wie get_cycle() auf dem MIPS ---*/
        C.Bits.EvtCount0 = 0xB;  /*--- Data  cache miss ---*/
        C.Bits.EvtCount1 = 0x0;  /*--- Instruction cache miss ---*/
        C.Bits.EnableCounters      = 1;
        write_p15_performance_monitor_control(C.Register);
    } else {
        C.Register = read_p15_performance_monitor_control();
        C.Bits.EnableCounters      = 0;
        write_p15_performance_monitor_control(C.Register);
    }
}
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static inline unsigned int arch_profile_perfcnt1(void) {
    return read_p15_performance_counter_0();
}

/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static inline unsigned int arch_profile_perfcnt2(void) {
    return read_p15_performance_counter_1();
}
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static inline unsigned int arch_profile_cpu_status(unsigned int restore_flags __maybe_unused) {
    /*--- todo ---*/
    return restore_flags;
}
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static inline int arch_is_linux_cpu(unsigned int core __maybe_unused, unsigned int tc __maybe_unused) {
    return 1;
}
#endif/*--- #ifndef __arch_profile_pumaX_h__ ---*/
