/*------------------------------------------------------------------------------------------*\
 *   
 *   Copyright (C) 2015 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
\*------------------------------------------------------------------------------------------*/
#if defined(CONFIG_AVM_WATCHDOG)
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/types.h>
#include <linux/smp.h>
#include <linux/init.h>
#include <linux/clk.h>
#include <linux/err.h>
#include <linux/io.h>
#include <linux/interrupt.h>
#include <linux/clk.h>

#include <asm/mach_avm.h>


void bcm_init_watchdog(void);
void bcm_configure_watchdog( unsigned int enabled, unsigned int timer, unsigned int userMode, unsigned int userThreshold );
void bcm_acknowledge_watchdog( void );

/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
void ar7wdt_hw_init(void) {
   printk("[ar7wdt_hw_init]: Setting up watchdog in user mode for 64s ...\n");
   bcm_init_watchdog();
   bcm_configure_watchdog(1, 0x2000000, 1, 2);
}

/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
void ar7wdt_hw_deinit(void) {
   printk("[ar7wdt_hw_deinit]: Switch off watchdog ...\n");
   bcm_configure_watchdog(0, 0x2000000, 1, 2);
}

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
void ar7wdt_hw_reboot(void) {
   ar7wdt_hw_deinit();
   printk("[ar7wdt_hw_reboot]: Reboot via watchdog ...\n");
   bcm_configure_watchdog(1, 0x100000, 1, 0);
}

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
void ar7wdt_hw_trigger(void) {
   //printk(KERN_ERR "[ar7wdt_hw_trigger]: Kick watchdog ...\n");
   bcm_acknowledge_watchdog();
}

#endif/*--- #if defined(CONFIG_AVM_WATCHDOG) ---*/
